pqxx::icursor_iterator Class Reference

Approximate istream_iterator for icursorstream. More...

`#include <cursor.hxx>`

Inheritance diagram for pqxx::icursor_iterator:

## Public Types

typedef icursorstream | istream_type
typedef istream_type::size_type | size_type
typedef istream_type::difference_type | difference_type

## Public Member Functions

| icursor_iterator () throw ()
| icursor_iterator (istream_type &) throw ()
| icursor_iterator (const icursor_iterator &) throw ()
| ~icursor_iterator () throw ()
const result & | operator* () const
const result * | operator-> () const
icursor_iterator & | operator++ ()
icursor_iterator | operator++ (int)
icursor_iterator & | operator+= (difference_type)
icursor_iterator & | operator= (const icursor_iterator &) throw ()
bool | operator== (const icursor_iterator &rhs) const
bool | operator!= (const icursor_iterator &rhs) const throw ()
bool | operator< (const icursor_iterator &rhs) const
bool | operator> (const icursor_iterator &rhs) const
bool | operator<= (const icursor_iterator &rhs) const
bool | operator>= (const icursor_iterator &rhs) const

## Friends

class | internal::gate::icursor_iterator_icursorstream

## Detailed Description

Approximate istream_iterator for icursorstream.

Intended as an implementation of an input_iterator (as defined by the C++ Standard Library), this class supports only two basic operations: reading the current element, and moving forward. In addition to the minimal guarantees for istream_iterators, this class supports multiple successive reads of the same position (the current result set is cached in the iterator) even after copying and even after new data have been read from the stream. This appears to be a requirement for input_iterators. Comparisons are also supported in the general case.

The iterator does not care about its own position, however. Moving an iterator forward moves the underlying stream forward and reads the data from the new stream position, regardless of the iterator's old position in the stream.

The stream's stride defines the granularity for all iterator movement or access operations, i.e. "ici += 1" advances the stream by one stride's worth of tuples, and "*ici++" reads one stride's worth of tuples from the stream.

Warning
  Do not read from the underlying stream or its cursor, move its read position, or change its stride, between the time the first icursor_iterator on it is created and the time its last icursor_iterator is destroyed.
  Manipulating these iterators within the context of a single cursor stream is not thread-safe. Creating a new iterator, copying one, or destroying one affects the stream as a whole.

## Member Typedef Documentation

## difference_type

typedef istream_type::difference_type pqxx::icursor_iterator::difference_type

## istream_type

typedef icursorstream pqxx::icursor_iterator::istream_type

## size_type

typedef istream_type::size_type pqxx::icursor_iterator::size_type

## Constructor & Destructor Documentation

## icursor_iterator() [1/3]

pqxx::icursor_iterator::icursor_iterator | ( |  | ) |
throw | ( |
| ) |  |

## icursor_iterator() [2/3]

pqxx::icursor_iterator::icursor_iterator | ( | istream_type & | s | ) |
throw | ( |
| ) |  |

explicit

## icursor_iterator() [3/3]

pqxx::icursor_iterator::icursor_iterator | ( | const icursor_iterator & | rhs | ) |
throw | ( |
| ) |  |

## ~icursor_iterator()

pqxx::icursor_iterator::~icursor_iterator | ( |  | ) |
throw | ( |
| ) |  |

## Member Function Documentation

## operator!=()

bool pqxx::icursor_iterator::operator!= | ( | const icursor_iterator & | rhs | ) | const
throw | ( |
| ) |  |

## operator*()

const result& pqxx::icursor_iterator::operator* | ( |  | ) | const

## operator++() [1/2]

icursor_iterator & pqxx::icursor_iterator::operator++ | ( |  | ) |

## operator++() [2/2]

icursor_iterator pqxx::icursor_iterator::operator++ | ( | int |  | ) |

## operator+=()

icursor_iterator & pqxx::icursor_iterator::operator+= | ( | difference_type | n | ) |

## operator->()

const result* pqxx::icursor_iterator::operator-> | ( |  | ) | const

## operator<()

bool pqxx::icursor_iterator::operator< | ( | const icursor_iterator & | rhs | ) | const

## operator<=()

bool pqxx::icursor_iterator::operator<= | ( | const icursor_iterator & | rhs | ) | const

## operator=()

icursor_iterator & pqxx::icursor_iterator::operator= | ( | const icursor_iterator & | rhs | ) |
throw | ( |
| ) |  |

## operator==()

bool pqxx::icursor_iterator::operator== | ( | const icursor_iterator & | rhs | ) | const

References pqxx::result::empty().

## operator>()

bool pqxx::icursor_iterator::operator> | ( | const icursor_iterator & | rhs | ) | const

## operator>=()

bool pqxx::icursor_iterator::operator>= | ( | const icursor_iterator & | rhs | ) | const

## Friends And Related Function Documentation

## internal::gate::icursor_iterator_icursorstream

friend class internal::gate::icursor_iterator_icursorstream

friend

The documentation for this class was generated from the following files:

- cursor.hxx
- cursor.cxx